#include <iostream.h> 
#include <fstream.h>
#include <string.h>
#include <ctype.h>

#include <stdarg.h>			// Header File For Variable Argument Routines
#include <stdio.h>

const int MAX_BUFFER = 64 * 1024;

char wikiBuffer[MAX_BUFFER];		//Bad practice, but useful...
char bufToken[128];

//End formatters; # means look for a number; and ( means looks a parenthesis, for is used a lot in regular text...
char *blue[] = {"int\0 ", "double\0 ", "float\0 ", "const\0 ", "return\0#", "while\0(", "for\0(", "#include\0 ",
				"char\0 ", "if\0(", "switch\0 ", "else\0 ", "void\0 ", "long\0 ", "do\0 ", "bool", NULL};

int arraylen(char *array[])
{
	for (int x = 0; array[x]; x++);
	return x;
}

void add(char *buffer, int &pos, char *string)
{
	for (unsigned int x = 0; x < strlen((const char *)string); x++)
	{
		buffer[pos++] = string[x];
		buffer[pos] = 0;
	}
}

void add(char *buffer, int &pos, const char *fmt, ...)
{
	char	text[256];
	va_list ap;

	if (fmt == NULL) return;

	va_start(ap, fmt);
	    vsprintf(text, fmt, ap);
	va_end(ap);

	add(buffer, pos, text);
}

void add(char *buffer, int &pos, char string)
{
	buffer[pos++] = string;
	buffer[pos] = 0;
}

const char *sep = "{}[]() ,.<>;:'";

bool seperator(char buf)
{
	for (unsigned int x = 0; x < strlen(sep); x++)
	{
		if (sep[x] == buf) return 1;
	}

	return 0;
}

char *token(char *buffer, int pos)
{
	bufToken[0] = 0;

	if (seperator(buffer[pos])) return (char *)bufToken;
	if (pos) if (!seperator(buffer[pos-1]) && buffer[pos-1] != 9) return (char *)bufToken;;

	for (unsigned int x = 0; x < 127; x++)
	{
		if (seperator(buffer[x+pos])) return (char *)bufToken;
		if (!buffer[x+pos]) return (char *)bufToken;

		bufToken[x] = buffer[x+pos];
		bufToken[x+1] = 0;
	}

	return (char *)bufToken;
}

//Thought strcmp was broken, wrong, but oh well... (debugging attempt)
bool strequ(char *str1, char *str2)
{
	int len1 = strlen(str1);
	int len2 = strlen(str2);

	if (len1 != len2) return 0;

	for (int x = 0; x < len1; x++)
	{
		if (str1[x] != str2[x]) return 0;
	}

	return 1;
}

bool makeBlue(char *buffer, int &pos, int &x)
{
	int items = arraylen(blue);
	int color;

	for (int y = 0; y < items; y++)
	{
		if (strequ(token(buffer, x), blue[y]) && (x+=strlen(blue[y])-1))
		{
			color = 0;

			//Handle format character
			if (blue[y][strlen(blue[y])+1] == ' ') color = 1;
			if (blue[y][strlen(blue[y])+1] == '(') for (int z = 0; z < 3; z++) if (buffer[x+z] == '(') color = 1;
			if (blue[y][strlen(blue[y])+1] == '#') for (int z = 0; z < 3; z++) if (isdigit(buffer[x+z])) color = 1;

			if (color) add(wikiBuffer, pos, "<font color=\"blue\">%s</font>", blue[y]);
			else add(wikiBuffer, pos, blue[y]);

			return 1;
		}
	}

	return 0;
}

char *wikify(char *buffer)
{
	int pos = 0;
	int x = 0;

	int length = strlen((const char *)buffer);

	while (x < length)
	{
		if (buffer[x] == 9) add(wikiBuffer, pos, "&nbsp&nbsp&nbsp&nbsp&nbsp");
		else
		if (makeBlue(buffer, pos, x));
		else
		if (buffer[x] == '/' && buffer[x+1] == '/')
		{
			add(wikiBuffer, pos, "<font color=\"green\">");

			while (x < length)
			{
				add(wikiBuffer, pos, buffer[x]);
				x++;
			}

			add(wikiBuffer, pos, "</font>");
		}
		else
		if (buffer[x] == '"' || buffer[x] == '<')
		{
			add(wikiBuffer, pos, "<font color=\"#400a50\">");

			do
			{
//				if (strequ(token(buffer, x), "<br>") && (x+=strlen("<br>")-1)) add(wikiBuffer, pos, "<pre><br></pre>");
//				else
				add(wikiBuffer, pos, buffer[x]);

				x++;
			}
			while (x < length && (buffer[x] != '"' || buffer[x] != '>') && buffer[x-1] != '\\');

			add(wikiBuffer, pos, "\"");
			add(wikiBuffer, pos, "</font>");
		}
		else
		if (buffer[x] == '\'' && buffer[x+2] == '\'')
		{
			add(wikiBuffer, pos, "<font color=\"#400a50\">");

			do
			{
				add(wikiBuffer, pos, buffer[x]);
				x++;
			}
			while (x < length && buffer[x] != '\'');

			add(wikiBuffer, pos, "'");
			add(wikiBuffer, pos, "</font>");
		}
		else
		add(wikiBuffer, pos, buffer[x]);

		x++;
	}

	return (char *)wikiBuffer;
}

bool special(char *buf)
{
	if (buf[0] == '=') return 1;
	if (buf[0] == '-') return 1;

	return 0;
}

int main(int argc, char **argv)
{
	char buffer[MAX_BUFFER];

	ifstream in;
	ofstream out;

	if (argc < 3)
    {
		cout << "Wikify vr 1.0" << endl << endl;
		cout << "Usage: wikify textfile wikifile" << endl << endl;
		cout << "programmed by: Josh Ferguson" << endl;
		cout << "This program is free for use, by anyone for any reason, with the author being" << endl << 
				"blame free for any unintended side effects." << endl;
		return 0;
	}

	in.open(argv[1], ios::in);

	if (!in)
    {
		cout << "Unable to open the input file " << '"' << argv[1] << '"' << endl;
		return 1;
	}

	out.open(argv[2], ios::out);

	if (!out)
	{
		cout << "Unable to open the output file " << '"' << argv[2] << '"' << endl;
		return 1;
	}

	while (!in.eof())
	{
		in.getline(buffer, MAX_BUFFER);

		if (strlen(buffer)) if (special(buffer)) out << wikify(buffer) << endl; else out << wikify(buffer) << "<br>" << endl;
		else out << "<br>" << endl;
	}

    in.close();
    out.close();

    return 0;
}